Index: /trunk/src/pvo-header.cc
===================================================================
--- /trunk/src/pvo-header.cc	(revision 50)
+++ /trunk/src/pvo-header.cc	(revision 51)
@@ -7,283 +7,288 @@
 using std::string;
 
-namespace Header
+namespace PVO
 {
 
-  SurveySchema::SurveySchema(const SurveySchema& s)
+  namespace Header
   {
-    for(int i=0;i<numKeywords;i++) startPosition[i]  = s.startPosition[i];
-    for(int i=0;i<numKeywords;i++) fieldLength[i]    = s.fieldLength[i];
-    for(int i=0;i<numKeywords;i++) fieldDimension[i] = s.fieldDimension[i];
-    minSamples = s.minSamples;
-    ant_x      = s.ant_x;
-    ant_y      = s.ant_y;   
-    ant_z      = s.ant_z;    
-    frontend   = s.frontend;
-    fd_poln    = s.fd_poln;  
-    fd_hand    = s.fd_hand; 
-    fd_sang    = s.fd_sang; 
-    fd_xyph    = s.fd_xyph; 
-    backend    = s.backend; 
-    beconfig   = s.beconfig; 
-    be_phase   = s.be_phase;
-    be_dcc     = s.be_dcc;
-    tcycle     = s.tcycle;   
-    obs_mode   = s.obs_mode; 
-    trk_mode   = s.trk_mode; 
-    scanlen    = s.scanlen;  
-    fd_mode    = s.fd_mode; 
-    cal_mode   = s.cal_mode; 
-    cal_freq   = s.cal_freq; 
-    cal_dcyc   = s.cal_dcyc; 
-    cal_phs    = s.cal_phs; 
-    bmaj       = s.bmaj;
-    bmin       = s.bmin;
-    bpa        = s.bpa;
-  }
-  //--------------------------------------------------------------------------
-
-  SurveySchema& SurveySchema::operator= (const SurveySchema& s)
-  {
-    if(this == &s) return *this;   // Gracefully handle self assignment
+
+    SurveySchema::SurveySchema(const SurveySchema& s)
+    {
+      for(int i=0;i<numKeywords;i++) startPosition[i]  = s.startPosition[i];
+      for(int i=0;i<numKeywords;i++) fieldLength[i]    = s.fieldLength[i];
+      for(int i=0;i<numKeywords;i++) fieldDimension[i] = s.fieldDimension[i];
+      minSamples = s.minSamples;
+      ant_x      = s.ant_x;
+      ant_y      = s.ant_y;   
+      ant_z      = s.ant_z;    
+      frontend   = s.frontend;
+      fd_poln    = s.fd_poln;  
+      fd_hand    = s.fd_hand; 
+      fd_sang    = s.fd_sang; 
+      fd_xyph    = s.fd_xyph; 
+      backend    = s.backend; 
+      beconfig   = s.beconfig; 
+      be_phase   = s.be_phase;
+      be_dcc     = s.be_dcc;
+      tcycle     = s.tcycle;   
+      obs_mode   = s.obs_mode; 
+      trk_mode   = s.trk_mode; 
+      scanlen    = s.scanlen;  
+      fd_mode    = s.fd_mode; 
+      cal_mode   = s.cal_mode; 
+      cal_freq   = s.cal_freq; 
+      cal_dcyc   = s.cal_dcyc; 
+      cal_phs    = s.cal_phs; 
+      bmaj       = s.bmaj;
+      bmin       = s.bmin;
+      bpa        = s.bpa;
+    }
+    //-----------------------------------------------------------------------
+
+    SurveySchema& SurveySchema::operator= (const SurveySchema& s)
+    {
+      if(this == &s) return *this;   // Gracefully handle self assignment
     
-    for(int i=0;i<numKeywords;i++) this->startPosition[i]  = s.startPosition[i];
-    for(int i=0;i<numKeywords;i++) this->fieldLength[i]    = s.fieldLength[i];
-    for(int i=0;i<numKeywords;i++) this->fieldDimension[i] = s.fieldDimension[i];
-    this->minSamples = s.minSamples;
-    this->ant_x      = s.ant_x;
-    this->ant_y      = s.ant_y;   
-    this->ant_z      = s.ant_z;    
-    this->frontend   = s.frontend;
-    this->fd_poln    = s.fd_poln;  
-    this->fd_hand    = s.fd_hand; 
-    this->fd_sang    = s.fd_sang; 
-    this->fd_xyph    = s.fd_xyph; 
-    this->backend    = s.backend; 
-    this->beconfig   = s.beconfig; 
-    this->be_phase   = s.be_phase;
-    this->be_dcc     = s.be_dcc;
-    this->tcycle     = s.tcycle;   
-    this->obs_mode   = s.obs_mode; 
-    this->trk_mode   = s.trk_mode; 
-    this->scanlen    = s.scanlen;  
-    this->fd_mode    = s.fd_mode; 
-    this->cal_mode   = s.cal_mode; 
-    this->cal_freq   = s.cal_freq; 
-    this->cal_dcyc   = s.cal_dcyc; 
-    this->cal_phs    = s.cal_phs;  
-    this->bmaj       = s.bmaj;
-    this->bmin       = s.bmin;
-    this->bpa        = s.bpa;
-
-    return *this;
-  }
-  //--------------------------------------------------------------------------
-
-  SurveySchema::SurveySchema(SURVEY surveyType)
-  {
-    /**
-     * The constructor used to define a setup for a specific survey. The choice
-     *  of survey determines the values of the start and length arrays for 
-     *  each field. If a field does not appear in the header setup for a given
-     *  survey, the start element is set to the RESERVE value, and the length
-     *  is set to 0.
-     * \param surveyType The type of survey, as expressed by the Header::SURVEY
-     * enumeration.
-     */
-
-    // Generic PHU Keywords that are the same for all surveys with PKS.
-    this->ant_x    = -4554231.5;
-    this->ant_y    = 2816759.1;
-    this->ant_z    = -3454036.3;
-    this->backend  = "FB_1BIT";
-    this->beconfig = "";
-    this->be_phase = 0;  // 0=unknown
-    this->be_dcc   = 0;
-    this->tcycle   = 0;
-    this->obs_mode = "SEARCH";
-    this->trk_mode = "TRACK";
-    this->cal_mode = "OFF"; 
-    this->cal_freq = 0.;
-    this->cal_dcyc = 0.;
-    this->cal_phs  = 0.;
+      for(int i=0;i<numKeywords;i++) this->startPosition[i]  = s.startPosition[i];
+      for(int i=0;i<numKeywords;i++) this->fieldLength[i]    = s.fieldLength[i];
+      for(int i=0;i<numKeywords;i++) this->fieldDimension[i] = s.fieldDimension[i];
+      this->minSamples = s.minSamples;
+      this->ant_x      = s.ant_x;
+      this->ant_y      = s.ant_y;   
+      this->ant_z      = s.ant_z;    
+      this->frontend   = s.frontend;
+      this->fd_poln    = s.fd_poln;  
+      this->fd_hand    = s.fd_hand; 
+      this->fd_sang    = s.fd_sang; 
+      this->fd_xyph    = s.fd_xyph; 
+      this->backend    = s.backend; 
+      this->beconfig   = s.beconfig; 
+      this->be_phase   = s.be_phase;
+      this->be_dcc     = s.be_dcc;
+      this->tcycle     = s.tcycle;   
+      this->obs_mode   = s.obs_mode; 
+      this->trk_mode   = s.trk_mode; 
+      this->scanlen    = s.scanlen;  
+      this->fd_mode    = s.fd_mode; 
+      this->cal_mode   = s.cal_mode; 
+      this->cal_freq   = s.cal_freq; 
+      this->cal_dcyc   = s.cal_dcyc; 
+      this->cal_phs    = s.cal_phs;  
+      this->bmaj       = s.bmaj;
+      this->bmin       = s.bmin;
+      this->bpa        = s.bpa;
+
+      return *this;
+    }
+    //--------------------------------------------------------------------------
+
+    SurveySchema::SurveySchema(SURVEY surveyType)
+    {
+      /**
+       * The constructor used to define a setup for a specific survey. The choice
+       *  of survey determines the values of the start and length arrays for 
+       *  each field. If a field does not appear in the header setup for a given
+       *  survey, the start element is set to the RESERVE value, and the length
+       *  is set to 0.
+       * \param surveyType The type of survey, as expressed by the Header::SURVEY
+       * enumeration.
+       */
+
+      // Generic PHU Keywords that are the same for all surveys with PKS.
+      this->ant_x    = -4554231.5;
+      this->ant_y    = 2816759.1;
+      this->ant_z    = -3454036.3;
+      this->backend  = "FB_1BIT";
+      this->beconfig = "";
+      this->be_phase = 0;  // 0=unknown
+      this->be_dcc   = 0;
+      this->tcycle   = 0;
+      this->obs_mode = "SEARCH";
+      this->trk_mode = "TRACK";
+      this->cal_mode = "OFF"; 
+      this->cal_freq = 0.;
+      this->cal_dcyc = 0.;
+      this->cal_phs  = 0.;
     
-    if(surveyType == S70){
-      //=============
-      // 70-cm Survey
-      //=============
-
-      this->minSamples = 512 * 1024;
-
-      this->frontend = "70cm_Cavity_Disk";
-      this->fd_mode  = "FA";
-      this->fd_poln  = "LIN";
-      this->fd_hand  = 1;
-      this->fd_sang  = 0.;
-      this->fd_xyph  = 0.;
-
-      this->bmaj = 0.75;
-      this->bmin = 0.75;
-      this->bpa = 0.;
-
-      this->scanlen = 152.;
-
-      // This initialises the SurveyHeader arrays for the S70 setup.
-      int s70Start[numKeywords] = {0,8,12,16,20,
-				   28,36,44,60,
-				   72,74,90,106,114,
-				   602,602,122,130,138,
-				   202,204,220,228,
-				   252,276,284,292,602,300,
-				   304,320,332,348,364,372,380,388,
-				   396,602,428,492,500,508,
-				   516,598,520,524,536,540,
-				   556,560,568,576,578,584,586,
-				   588,602,602,602,602};
-      for(int i=0;i<numKeywords;i++) this->startPosition[i] = s70Start[i];
+      if(surveyType == S70){
+	//=============
+	// 70-cm Survey
+	//=============
+
+	this->minSamples = 512 * 1024;
+
+	this->frontend = "70cm_Cavity_Disk";
+	this->fd_mode  = "FA";
+	this->fd_poln  = "LIN";
+	this->fd_hand  = 1;
+	this->fd_sang  = 0.;
+	this->fd_xyph  = 0.;
+
+	this->bmaj = 0.75;
+	this->bmin = 0.75;
+	this->bpa = 0.;
+
+	this->scanlen = 152.;
+
+	// This initialises the SurveyHeader arrays for the S70 setup.
+	int s70Start[numKeywords] = {0,8,12,16,20,
+				     28,36,44,60,
+				     72,74,90,106,114,
+				     602,602,122,130,138,
+				     202,204,220,228,
+				     252,276,284,292,602,300,
+				     304,320,332,348,364,372,380,388,
+				     396,602,428,492,500,508,
+				     516,598,520,524,536,540,
+				     556,560,568,576,578,584,586,
+				     588,602,602,602,602};
+	for(int i=0;i<numKeywords;i++) this->startPosition[i] = s70Start[i];
       
-      int s70Length[numKeywords] = {8,4,4,4,8,
-				    8,8,16,12,
-				    2,16,16,8,8,
-				    0,0,8,8,64,
-				    2,8,4,12,
-				    12,4,8,8,0,4,
-				    16,12,16,16,8,8,8,8,
-				    8,0,8,8,8,8,
-				    4,4,4,12,4,16,
-				    2,8,4,2,6,2,2,
-				    10,0,0,0,38};
-      for(int i=0;i<numKeywords;i++) this->fieldLength[i] = s70Length[i];
-
-      int s70Dim[numKeywords] = {1,1,1,1,1,
-				 1,1,1,1,
-				 1,1,1,1,1,
-				 1,1,1,1,1,
-				 1,2,2,2,
-				 2,2,1,1,1,1,
-				 1,1,1,1,1,1,1,1,
-				 4,1,8,1,1,1,
-				 1,1,1,1,1,1,
-				 2,1,2,1,1,1,1,
-				 1,1,1,1,1};
-      for(int i=0;i<numKeywords;i++) this->fieldDimension[i] = s70Dim[i];
-    }
-    else if(surveyType == PM || surveyType == PH){
-      //==================
-      // Multibeam Surveys
-      //==================
-
-      this->minSamples = 2050 * 4096;
-
-      this->frontend = "20cm_MB";
-      this->fd_poln  = "LIN";
-      this->fd_hand  = 1;
-      this->fd_sang  = -90.;
-      this->fd_xyph  = 0.;
-      this->beconfig = "";
-      this->fd_mode  = "CPA";
-//       this->fa_req  = 30.;
-
-      this->bmaj = 0.24;
-      this->bmin = 0.24;
-      this->bpa = 0.;
-
-      if(surveyType == PM) this->scanlen = 2100.;
-      else                 this->scanlen = 265.;
-
-      // This initialises the SurveyHeader arrays for the PM setup.
-      int pmStart[numKeywords] = {0,6,10,16,20,
-				  28,36,44,60,
-				  72,74,90,106,114,
-				  122,130,618,618,138,
-				  202,204,220,228,
-				  252,276,284,292,300,302,
-				  304,320,332,348,364,372,380,388,
-				  618,396,412,492,500,508,
-				  618,516,520,524,618,540,
-				  556,560,568,576,578,584,586,
-				  588,598,606,614,618};
-      for(int i=0;i<numKeywords;i++) this->startPosition[i] = pmStart[i];
+	int s70Length[numKeywords] = {8,4,4,4,8,
+				      8,8,16,12,
+				      2,16,16,8,8,
+				      0,0,8,8,64,
+				      2,8,4,12,
+				      12,4,8,8,0,4,
+				      16,12,16,16,8,8,8,8,
+				      8,0,8,8,8,8,
+				      4,4,4,12,4,16,
+				      2,8,4,2,6,2,2,
+				      10,0,0,0,38};
+	for(int i=0;i<numKeywords;i++) this->fieldLength[i] = s70Length[i];
+
+	int s70Dim[numKeywords] = {1,1,1,1,1,
+				   1,1,1,1,
+				   1,1,1,1,1,
+				   1,1,1,1,1,
+				   1,2,2,2,
+				   2,2,1,1,1,1,
+				   1,1,1,1,1,1,1,1,
+				   4,1,8,1,1,1,
+				   1,1,1,1,1,1,
+				   2,1,2,1,1,1,1,
+				   1,1,1,1,1};
+	for(int i=0;i<numKeywords;i++) this->fieldDimension[i] = s70Dim[i];
+      }
+      else if(surveyType == PM || surveyType == PH){
+	//==================
+	// Multibeam Surveys
+	//==================
+
+	this->minSamples = 2050 * 4096;
+
+	this->frontend = "20cm_MB";
+	this->fd_poln  = "LIN";
+	this->fd_hand  = 1;
+	this->fd_sang  = -90.;
+	this->fd_xyph  = 0.;
+	this->beconfig = "";
+	this->fd_mode  = "CPA";
+	//       this->fa_req  = 30.;
+
+	this->bmaj = 0.24;
+	this->bmin = 0.24;
+	this->bpa = 0.;
+
+	if(surveyType == PM) this->scanlen = 2100.;
+	else                 this->scanlen = 265.;
+
+	// This initialises the SurveyHeader arrays for the PM setup.
+	int pmStart[numKeywords] = {0,6,10,16,20,
+				    28,36,44,60,
+				    72,74,90,106,114,
+				    122,130,618,618,138,
+				    202,204,220,228,
+				    252,276,284,292,300,302,
+				    304,320,332,348,364,372,380,388,
+				    618,396,412,492,500,508,
+				    618,516,520,524,618,540,
+				    556,560,568,576,578,584,586,
+				    588,598,606,614,618};
+	for(int i=0;i<numKeywords;i++) this->startPosition[i] = pmStart[i];
       
-      int pmLength[numKeywords] = {6,4,6,4,8,
-				   8,8,16,12,
-				   2,16,16,8,8,
-				   8,8,0,0,64,
-				   2,8,4,12,
-				   12,4,8,8,2,1,
-				   16,12,16,16,8,8,8,8,
-				   0,4,4,8,8,8,
-				   0,4,4,16,0,16,
-				   2,8,4,2,6,2,2,
-				   10,8,8,4,22};
-      for(int i=0;i<numKeywords;i++) this->fieldLength[i] = pmLength[i];
-
-      int pmDim[numKeywords] = {1,1,1,1,1,
-				1,1,1,1,
-				1,1,1,1,1,
-				1,1,1,1,1,
-				1,2,2,2,
-				2,2,1,1,1,2,
-				1,1,1,1,1,1,1,1,
-				1,4,20,1,1,1,
-				1,1,1,1,1,1,
-				2,1,2,1,1,1,1,
-				1,1,1,1,1};
-      for(int i=0;i<numKeywords;i++) this->fieldDimension[i] = pmDim[i];
-    }
-    //     else throw xBadSurvey(surveyType);
-  }
-  //--------------------------------------------------------------------------
-
-  template <class T> 
-  T SurveySchema::readParameter(string headerString, int field,
-				int elementNumber)
-  {
-    /**
-     * Read a parameter from a certain field in a header string. The function
-     *  is templated, so one can obtain a numerical value or the string
-     *  representation.
-     * \param headerString The character string containing the full header.
-     * \param field The number of the desired header field. Can use the 
-     *  Header::FIELDS enumeration.
-     * \param elementNumber Which element of a multi-valued field to return. 
-     *  Defaults to 0 (ie. the first element).
-     * \return The value of the parameter, in the format in which the function 
-     *  is instantiated.
-     */
-    int dim = this->fieldDimension[field];
-    int length = this->fieldLength[field];
-    int pos = this->startPosition[field];
-    std::stringstream ss;
-    std::vector<T> output(dim);
-    for(int i=0;i<dim;i++){
-      ss.str( headerString.substr(pos+elementNumber*length, length) );
-      ss >> output[i];    
-    }
-    return output[elementNumber];
-  }
-  template <> string 
-  SurveySchema::readParameter<string>(string headerString, 
-				      int field, int elementNumber)
-  {
-    //    int dim = this->fieldDimension[field];
-    int length = this->fieldLength[field];
-    int pos = this->startPosition[field];
-    return headerString.substr(pos+elementNumber*length, length);
-  }
-  template int SurveySchema::readParameter<int>(string headerString, 
-						int field,
-						int elementNumber);
-  template float SurveySchema::readParameter<float>(string headerString, 
-						    int field,
-						    int elementNumber);
-  template double SurveySchema::readParameter<double>(string headerString, 
+	int pmLength[numKeywords] = {6,4,6,4,8,
+				     8,8,16,12,
+				     2,16,16,8,8,
+				     8,8,0,0,64,
+				     2,8,4,12,
+				     12,4,8,8,2,1,
+				     16,12,16,16,8,8,8,8,
+				     0,4,4,8,8,8,
+				     0,4,4,16,0,16,
+				     2,8,4,2,6,2,2,
+				     10,8,8,4,22};
+	for(int i=0;i<numKeywords;i++) this->fieldLength[i] = pmLength[i];
+
+	int pmDim[numKeywords] = {1,1,1,1,1,
+				  1,1,1,1,
+				  1,1,1,1,1,
+				  1,1,1,1,1,
+				  1,2,2,2,
+				  2,2,1,1,1,2,
+				  1,1,1,1,1,1,1,1,
+				  1,4,20,1,1,1,
+				  1,1,1,1,1,1,
+				  2,1,2,1,1,1,1,
+				  1,1,1,1,1};
+	for(int i=0;i<numKeywords;i++) this->fieldDimension[i] = pmDim[i];
+      }
+      //     else throw xBadSurvey(surveyType);
+    }
+    //--------------------------------------------------------------------------
+
+    template <class T> 
+    T SurveySchema::readParameter(string headerString, int field,
+				  int elementNumber)
+    {
+      /**
+       * Read a parameter from a certain field in a header string. The function
+       *  is templated, so one can obtain a numerical value or the string
+       *  representation.
+       * \param headerString The character string containing the full header.
+       * \param field The number of the desired header field. Can use the 
+       *  Header::FIELDS enumeration.
+       * \param elementNumber Which element of a multi-valued field to return. 
+       *  Defaults to 0 (ie. the first element).
+       * \return The value of the parameter, in the format in which the function 
+       *  is instantiated.
+       */
+      int dim = this->fieldDimension[field];
+      int length = this->fieldLength[field];
+      int pos = this->startPosition[field];
+      std::stringstream ss;
+      std::vector<T> output(dim);
+      for(int i=0;i<dim;i++){
+	ss.str( headerString.substr(pos+elementNumber*length, length) );
+	ss >> output[i];    
+      }
+      return output[elementNumber];
+    }
+    template <> string 
+    SurveySchema::readParameter<string>(string headerString, 
+					int field, int elementNumber)
+    {
+      //    int dim = this->fieldDimension[field];
+      int length = this->fieldLength[field];
+      int pos = this->startPosition[field];
+      return headerString.substr(pos+elementNumber*length, length);
+    }
+    template int SurveySchema::readParameter<int>(string headerString, 
+						  int field,
+						  int elementNumber);
+    template float SurveySchema::readParameter<float>(string headerString, 
 						      int field,
 						      int elementNumber);
-  template string SurveySchema::readParameter<string>(string headerString, 
-						      int field,
-						      int elementNumber);
-  //--------------------------------------------------------------------------
-
-
+    template double SurveySchema::readParameter<double>(string headerString, 
+							int field,
+							int elementNumber);
+    template string SurveySchema::readParameter<string>(string headerString, 
+							int field,
+							int elementNumber);
+    //--------------------------------------------------------------------------
+
+
+
+  }
 
 }
Index: /trunk/src/pvo-header.hh
===================================================================
--- /trunk/src/pvo-header.hh	(revision 50)
+++ /trunk/src/pvo-header.hh	(revision 51)
@@ -5,185 +5,190 @@
 #include <fstream>  
 
-/** This controls how the headers of existing files are interpreted. */
-namespace Header
+namespace PVO
 {
-  /** Codes for the different surveys.*/
-  enum SURVEY { S70=0, ///< 70-cm Survey (Parkes Southern Pulsar Survey).
-		PM,    ///< Parkes Multibeam Survey
-		PH,    ///< Parkes High-Latitude (multibeam) Survey
-		DUD,   ///< Unknown survey -- this may be a problem!
-		NONEXISTENT ///< File does not exist.
-  };
 
-  /** Human-readable names for the surveys */
-  const std::string surveyNames[DUD+1] = {
-"70-cm survey", 
-"Parkes Multibeam survey", 
-"Parkes High-latitude survey", 
-"Not a valid survey" 
-  };
-
-  /**
-   *  What survey does a file contain?
-   *
-   *  Reads the first few bytes of a file, which contain information about
-   *  the type of survey data recorded in the file.
-   *  \param file String with name of the file to be examined.
-   *  \return An enumerated Header::SURVEY type.
-   */
-  inline SURVEY idSurvey(std::string file)
+  /** This controls how the headers of existing files are interpreted. */
+  namespace Header
   {
-    std::ifstream fin;
-    fin.open(file.c_str(), std::ios::binary);
-    if(fin.fail()){
-      fin.close();
-      return NONEXISTENT;
-    }
-    char *hdr = new char[5];
-    fin.read( hdr, 5*sizeof(char) );
-    fin.close();
-    hdr[4] = '\0';
-    unsigned char compstring_s70[5] = {182, 'm', 'm', 219, 0};
-    unsigned char compstring_pm[4] = {'P', 'M', 'D'};
-    compstring_pm[3] = '\0';
-    SURVEY returnval;
-    if(strcmp((const char*)compstring_s70,hdr)==0) returnval = S70;
-    else if(strncmp((const char*)compstring_pm,hdr,3)==0) returnval = PM;
-    else returnval = DUD;
-    delete [] hdr;
-    return returnval;
-  }
-
-  /** Codes for the different moving states. \deprecated */
-  enum ISMOVING { NOTGRID=0, POINT, MOVING, SCANNING };
-
-  /** Codes representing the different header keywords */
-  enum FIELDS 
-    {CODE=0, VERSION, TAPENR, SCAN_CNTR, BLK_CNTR, 
-     DATE, MJD, UT_STRT, LST_STRT, 
-     COORD_TYPE, RA_STRT, DEC_STRT, GL_STRT, GB_STRT, 
-     FEED_ANGLE, OBS_TIME, SCAN_RATE, SCAN_LEN, COMMENT, 
-     NFILTER, CHANBW, NCHAN, FREQ_CHAN1, 
-     SAMP_INT, SAMP_GRP, GRP_BLK, BLK_SEC, FDCNTRL, DATA_TYPE,
-     UT, LST, RA, DEC, GL, GB, TEL_ZEN, TEL_AZ, 
-     STATUS, ATTEN, TPOWER, NBLK_READ, SCAN_RATEL, SCAN_RATEB, 
-     BYTE_GRP, NBEAM, IBEAM, PSRNAME, DATA_TWO, OBS_FILEN, 
-     NBITS, DDM, NDDCH, MOVE, PNTERR, TREE, NSYS, 
-     TELID, PANGLE, SMP_BSW, CAL_CYCLE, RESERVE
+    /** Codes for the different surveys.*/
+    enum SURVEY { S70=0, ///< 70-cm Survey (Parkes Southern Pulsar Survey).
+		  PM,    ///< Parkes Multibeam Survey
+		  PH,    ///< Parkes High-Latitude (multibeam) Survey
+		  DUD,   ///< Unknown survey -- this may be a problem!
+		  NONEXISTENT ///< File does not exist.
     };
 
-  const int numKeywords = RESERVE + 1; ///< The total number of keywords.
+    /** Human-readable names for the surveys */
+    const std::string surveyNames[DUD+1] = {
+      "70-cm survey", 
+      "Parkes Multibeam survey", 
+      "Parkes High-latitude survey", 
+      "Not a valid survey" 
+    };
+
+    /**
+     *  What survey does a file contain?
+     *
+     *  Reads the first few bytes of a file, which contain information about
+     *  the type of survey data recorded in the file.
+     *  \param file String with name of the file to be examined.
+     *  \return An enumerated Header::SURVEY type.
+     */
+    inline SURVEY idSurvey(std::string file)
+    {
+      std::ifstream fin;
+      fin.open(file.c_str(), std::ios::binary);
+      if(fin.fail()){
+	fin.close();
+	return NONEXISTENT;
+      }
+      char *hdr = new char[5];
+      fin.read( hdr, 5*sizeof(char) );
+      fin.close();
+      hdr[4] = '\0';
+      unsigned char compstring_s70[5] = {182, 'm', 'm', 219, 0};
+      unsigned char compstring_pm[4] = {'P', 'M', 'D'};
+      compstring_pm[3] = '\0';
+      SURVEY returnval;
+      if(strcmp((const char*)compstring_s70,hdr)==0) returnval = S70;
+      else if(strncmp((const char*)compstring_pm,hdr,3)==0) returnval = PM;
+      else returnval = DUD;
+      delete [] hdr;
+      return returnval;
+    }
+
+    /** Codes for the different moving states. \deprecated */
+    enum ISMOVING { NOTGRID=0, POINT, MOVING, SCANNING };
+
+    /** Codes representing the different header keywords */
+    enum FIELDS 
+      {CODE=0, VERSION, TAPENR, SCAN_CNTR, BLK_CNTR, 
+       DATE, MJD, UT_STRT, LST_STRT, 
+       COORD_TYPE, RA_STRT, DEC_STRT, GL_STRT, GB_STRT, 
+       FEED_ANGLE, OBS_TIME, SCAN_RATE, SCAN_LEN, COMMENT, 
+       NFILTER, CHANBW, NCHAN, FREQ_CHAN1, 
+       SAMP_INT, SAMP_GRP, GRP_BLK, BLK_SEC, FDCNTRL, DATA_TYPE,
+       UT, LST, RA, DEC, GL, GB, TEL_ZEN, TEL_AZ, 
+       STATUS, ATTEN, TPOWER, NBLK_READ, SCAN_RATEL, SCAN_RATEB, 
+       BYTE_GRP, NBEAM, IBEAM, PSRNAME, DATA_TWO, OBS_FILEN, 
+       NBITS, DDM, NDDCH, MOVE, PNTERR, TREE, NSYS, 
+       TELID, PANGLE, SMP_BSW, CAL_CYCLE, RESERVE
+      };
+
+    const int numKeywords = RESERVE + 1; ///< The total number of keywords.
 
 
-  /**
-   * Definitions of the different survey headers.
-   *
-   * This class contains the information needed to make sense of the header
-   *  strings found in the existing survey data files. Each survey has a 
-   *  different header structure, and so this class handles the definitions
-   *  of where one keyword ends and another starts.
-   */
+    /**
+     * Definitions of the different survey headers.
+     *
+     * This class contains the information needed to make sense of the header
+     *  strings found in the existing survey data files. Each survey has a 
+     *  different header structure, and so this class handles the definitions
+     *  of where one keyword ends and another starts.
+     */
 
-  class SurveySchema
-  {
-  public:
-    SurveySchema(){};
-    virtual ~SurveySchema(){};
-    SurveySchema(SURVEY surveyType); ///< Survey-specific constructor
-    SurveySchema(const SurveySchema& s); ///< Copy constructor
-    SurveySchema& operator= (const SurveySchema& s); ///< Copy constructor.
+    class SurveySchema
+    {
+    public:
+      SurveySchema(){};
+      virtual ~SurveySchema(){};
+      SurveySchema(SURVEY surveyType); ///< Survey-specific constructor
+      SurveySchema(const SurveySchema& s); ///< Copy constructor
+      SurveySchema& operator= (const SurveySchema& s); ///< Copy constructor.
 
-    /** Get the character number that a given field starts at. */
-    int getStartPosition(int field){return startPosition[field];};
-    /** Get the number of characters in a given field. */
-    int getFieldLength(int field){return fieldLength[field];};
-     /** Get the number of elements that a given field contains. */
-    int getFieldDimension(int field){return fieldDimension[field];};
+      /** Get the character number that a given field starts at. */
+      int getStartPosition(int field){return startPosition[field];};
+      /** Get the number of characters in a given field. */
+      int getFieldLength(int field){return fieldLength[field];};
+      /** Get the number of elements that a given field contains. */
+      int getFieldDimension(int field){return fieldDimension[field];};
 
-    template <class T> T readParameter(std::string headerString, int field,
-				       int elementNumber = 0);
-    ///< Read a particular header parameter.
+      template <class T> T readParameter(std::string headerString, int field,
+					 int elementNumber = 0);
+      ///< Read a particular header parameter.
 
-    /** Exception class for a bad survey code. Not used at the moment. */
-    class xBadSurvey{
-    public:
-      xBadSurvey(std::string s){surveyName=s;};
-      virtual ~xBadSurvey(){};
-      std::string getSurvey(){return surveyName;};
+      /** Exception class for a bad survey code. Not used at the moment. */
+      class xBadSurvey{
+      public:
+	xBadSurvey(std::string s){surveyName=s;};
+	virtual ~xBadSurvey(){};
+	std::string getSurvey(){return surveyName;};
+      private:
+	std::string surveyName;
+      };
+
+      long        getMinSamples(){return minSamples;};
+
+      // accessor functions for PHU keyword values -- only get functions needed.
+      double      getAntX(){return ant_x;};
+      double      getAntY(){return ant_y;};
+      double      getAntZ(){return ant_z;};
+      std::string getFrontend(){return frontend;};
+      std::string getFd_poln(){return fd_poln;};
+      int         getFd_hand(){return fd_hand;};
+      float       getFd_sang(){return fd_sang;};
+      float       getFd_xyph(){return fd_xyph;};
+      std::string getBackend(){return backend;};
+      std::string getBeconfig(){return beconfig;};
+      int         getBe_phase(){return be_phase;};
+      int         getBe_dcc(){return be_dcc;};
+      double      getTcycle(){return tcycle;};
+      std::string getObs_mode(){return obs_mode;};
+      std::string getTrk_mode(){return trk_mode;};
+      float       getScanlen(){return scanlen;};
+      std::string getFd_mode(){return fd_mode;};
+      std::string getCal_mode(){return cal_mode;};
+      float       getCal_freq(){return cal_freq;};
+      float       getCal_dcyc(){return cal_dcyc;};
+      float       getCal_phs(){return cal_phs;};
+      float       getBmaj(){return bmaj;};
+      float       getBmin(){return bmin;};
+      float       getBpa(){return bpa;};
+
+ 
     private:
-      std::string surveyName;
+      int startPosition[numKeywords];  ///< The character number at
+      ///   which each field commences.
+      int fieldLength[numKeywords];    ///< The number of characters in
+      ///   each field.
+      int fieldDimension[numKeywords]; ///< The number of elements in
+      ///   each field.
+
+      long        minSamples;  ///< The minimum number of samples to be
+      ///   included in a FITS file
+
+      // The following are PHU keywords that are survey-dependent.
+      double      ant_x;
+      double      ant_y;
+      double      ant_z;
+      std::string frontend;
+      std::string fd_poln;
+      int         fd_hand;
+      float       fd_sang;
+      float       fd_xyph;
+      std::string backend;
+      std::string beconfig;
+      int         be_phase;
+      int         be_dcc;
+      double      tcycle;
+      std::string obs_mode;
+      std::string trk_mode;
+      float       scanlen;
+      std::string fd_mode;
+      std::string cal_mode;
+      float       cal_freq;
+      float       cal_dcyc;
+      float       cal_phs;
+
+      float       bmaj;
+      float       bmin;
+      float       bpa;
+
+
     };
 
-    long        getMinSamples(){return minSamples;};
+    // Inline functions
 
-    // accessor functions for PHU keyword values -- only get functions needed.
-    double      getAntX(){return ant_x;};
-    double      getAntY(){return ant_y;};
-    double      getAntZ(){return ant_z;};
-    std::string getFrontend(){return frontend;};
-    std::string getFd_poln(){return fd_poln;};
-    int         getFd_hand(){return fd_hand;};
-    float       getFd_sang(){return fd_sang;};
-    float       getFd_xyph(){return fd_xyph;};
-    std::string getBackend(){return backend;};
-    std::string getBeconfig(){return beconfig;};
-    int         getBe_phase(){return be_phase;};
-    int         getBe_dcc(){return be_dcc;};
-    double      getTcycle(){return tcycle;};
-    std::string getObs_mode(){return obs_mode;};
-    std::string getTrk_mode(){return trk_mode;};
-    float       getScanlen(){return scanlen;};
-    std::string getFd_mode(){return fd_mode;};
-    std::string getCal_mode(){return cal_mode;};
-    float       getCal_freq(){return cal_freq;};
-    float       getCal_dcyc(){return cal_dcyc;};
-    float       getCal_phs(){return cal_phs;};
-    float       getBmaj(){return bmaj;};
-    float       getBmin(){return bmin;};
-    float       getBpa(){return bpa;};
-
- 
-  private:
-    int startPosition[numKeywords];  ///< The character number at
-				     ///   which each field commences.
-    int fieldLength[numKeywords];    ///< The number of characters in
-				     ///   each field.
-    int fieldDimension[numKeywords]; ///< The number of elements in
-				     ///   each field.
-
-    long        minSamples;  ///< The minimum number of samples to be
-                             ///   included in a FITS file
-
-    // The following are PHU keywords that are survey-dependent.
-    double      ant_x;
-    double      ant_y;
-    double      ant_z;
-    std::string frontend;
-    std::string fd_poln;
-    int         fd_hand;
-    float       fd_sang;
-    float       fd_xyph;
-    std::string backend;
-    std::string beconfig;
-    int         be_phase;
-    int         be_dcc;
-    double      tcycle;
-    std::string obs_mode;
-    std::string trk_mode;
-    float       scanlen;
-    std::string fd_mode;
-    std::string cal_mode;
-    float       cal_freq;
-    float       cal_dcyc;
-    float       cal_phs;
-
-    float       bmaj;
-    float       bmin;
-    float       bpa;
-
-
-  };
-
-  // Inline functions
+  }
 
 }
